/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   SELOR - Servidor de Emails Livre Orientado a Regras                           
   Programado por Lucas Priori                                                   
   Versao: 1.2                                                                   
                                                                                 
   Linux - make linux                                                            
       or  make linux_nocap                                                      
   FreeBSD - gmake freebsd                                                       
                                                                                 
  *******************************************************************            
  Selor e um agente MTA para troca de emails via protocolo SMTP                 
  Copyright (C) 2012,2013,2014  Lucas Priori                                     
                                                                                 
  This program is free software; you can redistribute it and/or                  
  modify it under the terms of the GNU General Public License                    
  as published by the Free Software Foundation; either version 2                 
  of the License, or (at your option) any later version.                         
                                                                                 
  This program is distributed in the hope that it will be useful,                
  but WITHOUT ANY WARRANTY; without even the implied warranty of                 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  
  GNU General Public License for more details.                                   
                                                                                 
  You should have received a copy of the GNU General Public License              
  along with this program; if not, write to the Free Software                    
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/

// Variaveis e estruturas
struct cpl_struct{
 char *orig;
 char *dest;
 unsigned int tamusado;
 unsigned int tambuffer;
};

// ---
struct str_dosd {            
 unsigned int ip;
 unsigned int timestamp;
 char *mem;
 char *fim_mem;
 char *atual_posi;
 unsigned int intervalo;
 unsigned int num_ocorr;
};


// Funcoes em Assembly 
//---------------------------------------------------------------------
extern char *pular_carac(char *string, int carac);
//---------------------------------------------------------------------
extern void str_arruma_crlf(char *string);
//---------------------------------------------------------------------
extern unsigned int selor_strncpy(char *destino, char *origem, unsigned int tam_str);
//---------------------------------------------------------------------
extern unsigned int special_cp(char *destino, char *origem, unsigned int tam_str);
//---------------------------------------------------------------------
extern unsigned int selor_superstrncpy(char *destino, unsigned int tam_str, ...);      // Ultimo parametro DEVE ser sempre NULL
//---------------------------------------------------------------------
extern unsigned int selor_strncat(char *destino, char *origem, unsigned int tam_str);
//---------------------------------------------------------------------
extern char t_inject_helo(char *str);
//---------------------------------------------------------------------
extern unsigned int conv_crlf(char *string1, char *string2, int num_bytes, char *ult_buffer, char **fim_header);
//---------------------------------------------------------------------
extern int cmp_str(char *string1, char *string2, int num_bytes);
//---------------------------------------------------------------------
extern int cmp_str_vars(char *string1, char *string2);
//---------------------------------------------------------------------
extern unsigned int base64_decod(char *str_destino, char *str_base64);
//---------------------------------------------------------------------
extern unsigned int base64_cod(char *str_base64, char *str_texto, int tamanho);
//---------------------------------------------------------------------
extern unsigned int selor_segcp(char *destino, char *origem);
//---------------------------------------------------------------------
extern int cpl(struct cpl_struct *);
//---------------------------------------------------------------------
extern char *itoa(unsigned int valor, int num_casas);
//---------------------------------------------------------------------
extern char tmasc(unsigned int ip, unsigned int rede, unsigned short mascara);
//---------------------------------------------------------------------
extern char dosd(struct str_dosd *);
//---------------------------------------------------------------------




// Funcoes em C
//---------------------------------------------------------------------
char *proc_str(char *string, char *texto);
//---------------------------------------------------------------------
void seq_modules(int *seq_ptr, char *mod_string);
//---------------------------------------------------------------------
int def_parametro(char *opcao, char *parametro);
//---------------------------------------------------------------------
void tempoesgotado(int sinal);
//---------------------------------------------------------------------
char *log_rettempo(void);
//---------------------------------------------------------------------
void rfc_date(char *retorno, time_t timestamp);
//---------------------------------------------------------------------
char log_msg(char *CAM_log);
//---------------------------------------------------------------------
void capta_sinal(int sinal);
//---------------------------------------------------------------------
unsigned int compute_slots(int *processos, unsigned int max_procs);
//---------------------------------------------------------------------
void reg_pid(int *processos, unsigned int max_procs, int num_pid);
//---------------------------------------------------------------------
int selor_send(int num_socket, char *buffer_local, int num_bytes, unsigned int flags);
//---------------------------------------------------------------------
int selor_recv(int num_socket, char *buffer_local, int num_bytes, unsigned int flags);
//---------------------------------------------------------------------
int selor_cmd_recv(int num_socket, char *buffer_local, int num_bytes, unsigned int flags);
//---------------------------------------------------------------------
int selor_smtp_recv(int num_socket, char *buffer_local, int num_bytes, unsigned int flags);
//---------------------------------------------------------------------
void smtp_resp(char *acrescimo, char tipo, char parametro);
//---------------------------------------------------------------------
char srs_encode(char *ret_buffer, int tam_ret_buffer, char *email, char *novo_dominio, char *chave, unsigned char shift_carac, unsigned int srs_timer);
//---------------------------------------------------------------------
char srs_decode(char *ret_buffer, int tam_ret_buffer, char *email, char *chave, unsigned char shift_carac, unsigned int srs_timer);
//---------------------------------------------------------------------
char smtp_dados_email(char *smtp_dados, struct dados_email *struct_email, unsigned int *tam);
//---------------------------------------------------------------------
char gravar_lista(unsigned int local_num_rcpts, FILE *local_arq, char *cam_arq, unsigned int num_tentativas, unsigned int num_report_erros);
//---------------------------------------------------------------------
void tratar_erro_modulo(int mod_indice);
//---------------------------------------------------------------------
char cache_mod_dom_local(char *dominio, char *ret_dom, unsigned int *indice_achado);
//---------------------------------------------------------------------
void resp_rcpt(int email_index, char *ip, char *resp);
//---------------------------------------------------------------------
void resp_rcpts(int email_index, char *ip, char *resp, char *id);
//---------------------------------------------------------------------
int dlocal(char *dlocal_str, char *arq_email, char *id, struct dados_email *dlocal_from, struct dados_email *dlocal_to);
//---------------------------------------------------------------------
//char sendmail(char *cam_email, char *id, char *remetente, char *destinatario);
char sendmail(char *cam_email, char *id, struct dados_email *local_from, struct dados_email *local_to);
//---------------------------------------------------------------------
void msg_queue(char *email_conteudo, char *remetente, char *destinatario, char *add_to_header);
//---------------------------------------------------------------------
char proc_id(char *id);
//---------------------------------------------------------------------

